# ---------------------------------------------------------------------------
# - SEC0003.als                                                             -
# - afnix:sec module test unit                                              -
# ---------------------------------------------------------------------------
# - This program is free software;  you can redistribute it  and/or  modify -
# - it provided that this copyright notice is kept intact.                  -
# -                                                                         -
# - This program  is  distributed in  the hope  that it will be useful, but -
# - without  any  warranty;  without  even   the   implied    warranty   of -
# - merchantability or fitness for a particular purpose.  In no event shall -
# - the copyright holder be liable for any  direct, indirect, incidental or -
# - special damages arising in any way out of the use of this software.     -
# ---------------------------------------------------------------------------
# - copyright (c) 1999-2008 amaury darsch                                   -
# ---------------------------------------------------------------------------

# @info   input cipher mode test unit
# @author amaury darsch

# get the module
interp:library "afnix-sec"

# create a symmetric key
const  key (afnix:sec:Key afnix:sec:Key:KSYM)
# create a block cipher with a key
const  bc  (afnix:sec:Aes key)

# create an input cipher in ecb mode
trans  ic   (afnix:sec:InputCipher bc)
assert true (afnix:sec:input-cipher-p ic)
# verify the input cipher parameters
assert afnix:sec:InputCipher:ECB (ic:get-mode)

# create an input cipher in cbc mode
trans  ic   (afnix:sec:InputCipher bc afnix:sec:InputCipher:CBC)
assert true (afnix:sec:input-cipher-p ic)
# verify the input cipher parameters
assert afnix:sec:InputCipher:CBC (ic:get-mode)

# create an input cipher in cfb mode
trans  ic   (afnix:sec:InputCipher bc afnix:sec:InputCipher:CFB)
assert true (afnix:sec:input-cipher-p ic)
# verify the input cipher parameters
assert afnix:sec:InputCipher:CFB (ic:get-mode)

# create an input cipher in cfb mode
trans  ic   (afnix:sec:InputCipher bc afnix:sec:InputCipher:OFB)
assert true (afnix:sec:input-cipher-p ic)
# verify the input cipher parameters
assert afnix:sec:InputCipher:OFB (ic:get-mode)
